//
// C++ Implementation: pixmaps
//
// Description:
//
//
// Author: Remi Villatel <maxilys@tele2.fr>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include "pixmaps.h"
#include "porcelainhandler.h"

#include <kdecoration.h>
#include <qpainter.h>
#include <kpixmapeffect.h>
#include <kpixmap.h>
#include <kpixmapio.h>
#include <qimage.h>
#include <qpixmap.h>

#include <qwidget.h>

// Static declarations for linking.
QPixmap *Pixmaps::active_button_ground = 0;
QPixmap *Pixmaps::inactive_button_ground = 0;

QImage *Pixmaps::active_help_normal = 0;
QImage *Pixmaps::active_max_normal = 0;
QImage *Pixmaps::active_restore_normal = 0;
QImage *Pixmaps::active_min_normal = 0;
QImage *Pixmaps::active_close_normal = 0;
QImage *Pixmaps::active_sticky_normal = 0;
QImage *Pixmaps::active_unsticky_normal = 0;
QImage *Pixmaps::active_above_normal = 0;
QImage *Pixmaps::active_below_normal = 0;

QImage *Pixmaps::active_help_hover = 0;
QImage *Pixmaps::active_max_hover = 0;
QImage *Pixmaps::active_restore_hover = 0;
QImage *Pixmaps::active_min_hover = 0;
QImage *Pixmaps::active_close_hover = 0;
QImage *Pixmaps::active_sticky_hover = 0;
QImage *Pixmaps::active_unsticky_hover = 0;
QImage *Pixmaps::active_above_hover = 0;
QImage *Pixmaps::active_below_hover = 0;

QImage *Pixmaps::active_help_sunken = 0;
QImage *Pixmaps::active_max_sunken = 0;
QImage *Pixmaps::active_restore_sunken = 0;
QImage *Pixmaps::active_min_sunken = 0;
QImage *Pixmaps::active_close_sunken = 0;
QImage *Pixmaps::active_sticky_sunken = 0;
QImage *Pixmaps::active_unsticky_sunken = 0;
QImage *Pixmaps::active_above_sunken = 0;
QImage *Pixmaps::active_below_sunken = 0;

QImage *Pixmaps::inactive_help_normal = 0;
QImage *Pixmaps::inactive_max_normal = 0;
QImage *Pixmaps::inactive_restore_normal = 0;
QImage *Pixmaps::inactive_min_normal = 0;
QImage *Pixmaps::inactive_close_normal = 0;
QImage *Pixmaps::inactive_sticky_normal = 0;
QImage *Pixmaps::inactive_unsticky_normal = 0;
QImage *Pixmaps::inactive_above_normal = 0;
QImage *Pixmaps::inactive_below_normal = 0;

QImage *Pixmaps::inactive_help_hover = 0;
QImage *Pixmaps::inactive_max_hover = 0;
QImage *Pixmaps::inactive_restore_hover = 0;
QImage *Pixmaps::inactive_min_hover = 0;
QImage *Pixmaps::inactive_close_hover = 0;
QImage *Pixmaps::inactive_sticky_hover = 0;
QImage *Pixmaps::inactive_unsticky_hover = 0;
QImage *Pixmaps::inactive_above_hover = 0;
QImage *Pixmaps::inactive_below_hover = 0;

QImage *Pixmaps::inactive_help_sunken = 0;
QImage *Pixmaps::inactive_max_sunken = 0;
QImage *Pixmaps::inactive_restore_sunken = 0;
QImage *Pixmaps::inactive_min_sunken = 0;
QImage *Pixmaps::inactive_close_sunken = 0;
QImage *Pixmaps::inactive_sticky_sunken = 0;
QImage *Pixmaps::inactive_unsticky_sunken = 0;
QImage *Pixmaps::inactive_above_sunken = 0;
QImage *Pixmaps::inactive_below_sunken = 0;

QPixmap *Pixmaps::active_titlebar = 0;
QPixmap *Pixmaps::active_titlebar_left = 0;
QPixmap *Pixmaps::active_titlebar_right = 0;
QPixmap *Pixmaps::inactive_titlebar = 0;
QPixmap *Pixmaps::inactive_titlebar_left = 0;
QPixmap *Pixmaps::inactive_titlebar_right = 0;

bool Pixmaps::pixmapsCreated = false;

// help.xpm
static int alias_help[] = {
	8,8,7,6,6,6,6,6,6,6,6,6,6,7,8,8,
	8,5,4,4,4,4,4,4,4,4,4,4,4,4,5,8,
	6,4,1,0,0,0,0,0,0,0,0,0,0,1,4,6,
	6,4,1,0,0,0,0,0,0,0,0,0,0,0,4,6,
	8,5,4,4,4,4,4,4,4,4,0,0,0,0,4,6,
	8,8,7,6,6,6,6,4,4,4,0,0,0,0,4,6,
	8,8,8,8,8,5,4,4,4,4,0,0,0,0,4,6,
	8,8,8,8,6,4,1,0,0,0,0,0,0,0,4,6,
	8,8,8,8,6,4,1,0,0,0,0,0,0,1,4,6,
	8,8,8,8,8,5,4,4,4,4,4,4,4,4,5,8,
	8,8,8,8,8,8,6,4,4,5,6,6,6,7,8,8,
	8,8,8,8,8,5,4,4,4,4,5,8,8,8,8,8,
	8,8,8,8,6,4,1,0,0,1,4,6,8,8,8,8,
	8,8,8,8,6,4,1,0,0,1,4,6,8,8,8,8,
	8,8,8,8,8,5,4,4,4,4,5,8,8,8,8,8,
	8,8,8,8,8,8,7,6,6,7,8,8,8,8,8,8
};
// max.xpm
static int alias_max[] = {
	8,8,7,6,6,6,6,6,6,6,6,6,6,7,8,8,
	8,5,4,4,4,4,4,4,4,4,4,4,4,4,5,8,
	7,4,1,0,0,0,0,0,0,0,0,0,0,1,4,7,
	6,4,0,0,0,0,0,0,0,0,0,0,0,0,4,6,
	6,4,0,0,0,0,0,0,0,0,0,0,0,0,4,6,
	6,4,4,4,4,4,4,4,4,4,4,4,4,4,4,6,
	6,4,2,2,2,2,2,2,2,2,2,2,2,2,4,6,
	6,4,0,0,0,0,0,0,0,0,0,0,0,0,4,6,
	6,4,0,0,0,0,0,0,0,0,0,0,0,0,4,6,
	6,4,0,0,0,0,0,0,0,0,0,0,0,0,4,6,
	6,4,0,0,0,0,0,0,0,0,0,0,0,0,4,6,
	6,4,0,0,0,0,0,0,0,0,0,0,0,0,4,6,
	6,4,0,0,0,0,0,0,0,0,0,0,0,0,4,6,
	7,4,1,0,0,0,0,0,0,0,0,0,0,1,4,7,
	8,5,4,4,4,4,4,4,4,4,4,4,4,4,5,8,
	8,8,7,6,6,6,6,6,6,6,6,6,6,7,8,8
};
// restore.xpm
static int alias_restore[] = {
	8,8,7,6,6,6,6,6,6,6,6,6,6,7,8,8,
	8,5,4,4,4,4,4,4,4,4,4,4,4,4,5,8,
	7,4,3,2,2,2,2,2,2,2,2,2,2,2,4,7,
	6,4,2,2,2,2,2,2,2,2,2,2,2,2,4,6,
	6,4,4,4,4,4,4,4,4,4,4,2,2,2,4,6,
	6,4,3,2,2,2,2,2,2,2,4,4,4,4,4,6,
	6,4,0,0,0,0,0,0,0,0,2,4,3,3,4,6,
	6,4,4,4,4,4,4,4,4,4,4,4,2,2,4,6,
	6,4,2,2,2,2,2,2,2,2,3,4,2,2,4,6,
	6,4,0,0,0,0,0,0,0,0,2,4,2,2,4,6,
	6,4,0,0,0,0,0,0,0,0,2,4,2,2,4,6,
	6,4,0,0,0,0,0,0,0,0,2,4,2,2,4,6,
	6,4,0,0,0,0,0,0,0,0,2,4,2,2,4,6,
	6,4,1,0,0,0,0,0,0,0,3,4,2,3,4,7,
	7,4,4,4,4,4,4,4,4,4,4,4,4,4,5,8,
	8,7,6,6,6,6,6,6,6,6,6,6,6,7,8,8
};
// min.xpm
static int alias_min[] = {
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
	8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
	8,8,7,6,6,6,6,6,6,6,6,6,6,7,8,8,
	8,5,4,4,4,4,4,4,4,4,4,4,4,4,5,8,
	6,4,1,0,0,0,0,0,0,0,0,0,0,1,4,6,
	6,4,1,0,0,0,0,0,0,0,0,0,0,1,4,6,
	8,5,4,4,4,4,4,4,4,4,4,4,4,4,5,8,
	8,8,7,6,6,6,6,6,6,6,6,6,6,7,8,8
};
// close.xpm
static int alias_close[] = {
	8,8,7,6,8,8,8,8,8,8,8,8,6,7,8,8,
	8,5,4,4,4,7,8,8,8,8,7,4,4,4,5,8,
	7,4,1,1,3,4,7,8,8,7,4,3,1,1,4,7,
	6,4,1,0,0,3,4,7,7,4,3,0,0,1,4,6,
	8,4,3,0,0,0,3,4,4,3,0,0,0,3,4,8,
	8,7,4,3,0,0,0,3,3,0,0,0,3,4,7,8,
	8,8,7,4,3,0,0,0,0,0,0,3,4,7,8,8,
	8,8,8,7,4,3,0,0,0,0,3,4,7,8,8,8,
	8,8,8,7,4,3,0,0,0,0,3,4,7,8,8,8,
	8,8,7,4,3,0,0,0,0,0,0,3,4,7,8,8,
	8,7,4,3,0,0,0,3,3,0,0,0,3,4,7,8,
	8,4,3,0,0,0,3,4,4,3,0,0,0,3,4,8,
	6,4,1,0,0,3,4,7,7,4,3,0,0,1,4,6,
	7,4,1,1,3,4,7,8,8,7,4,3,1,1,4,7,
	8,5,4,4,4,7,8,8,8,8,7,4,4,4,5,8,
	8,8,7,6,8,8,8,8,8,8,8,8,6,7,8,8
};
// sticky.xpm
static int alias_sticky[] = {
	8,8,8,8,8,8,6,6,6,6,8,8,8,8,8,8,
	8,8,8,7,5,4,4,4,4,4,4,5,7,8,8,8,
	8,8,7,4,4,3,2,0,0,2,3,4,4,7,8,8,
	8,7,4,4,1,0,0,0,0,0,0,1,4,4,7,8,
	8,5,4,1,0,0,0,0,0,0,0,0,1,4,5,8,
	8,4,3,0,0,0,0,0,0,0,0,0,0,3,4,8,
	6,4,2,0,0,0,0,0,0,0,0,0,0,2,4,6,
	6,4,0,0,0,0,0,0,0,0,0,0,0,0,4,6,
	6,4,0,0,0,0,0,0,0,0,0,0,0,0,4,6,
	6,4,2,0,0,0,0,0,0,0,0,0,0,2,4,6,
	8,4,3,0,0,0,0,0,0,0,0,0,0,3,4,8,
	8,5,4,1,0,0,0,0,0,0,0,0,1,4,5,8,
	8,7,4,4,1,0,0,0,0,0,0,1,4,4,7,8,
	8,8,7,4,4,3,2,0,0,2,3,4,4,7,8,8,
	8,8,8,7,5,4,4,4,4,4,4,5,7,8,8,8,
	8,8,8,8,8,8,6,6,6,6,8,8,8,8,8,8
};
// unsticky.xpm
static int alias_unsticky[] = {
	8,8,8,8,8,8,6,6,6,6,8,8,8,8,8,8,
	8,8,8,7,5,4,4,4,4,4,4,5,7,8,8,8,
	8,8,7,4,4,3,2,0,0,2,3,4,4,7,8,8,
	8,7,4,4,1,0,0,0,0,0,0,1,4,4,7,8,
	8,5,4,1,0,0,2,4,4,2,0,0,1,4,5,8,
	8,4,3,0,0,3,4,4,4,4,3,0,0,3,4,8,
	6,4,2,0,2,4,5,8,8,5,4,2,0,2,4,6,
	6,4,0,0,4,4,8,8,8,8,4,4,0,0,4,6,
	6,4,0,0,4,4,8,8,8,8,4,4,0,0,4,6,
	6,4,2,0,2,4,5,8,8,5,4,2,0,2,4,6,
	8,4,3,0,0,3,4,4,4,4,3,0,0,3,4,8,
	8,5,4,1,0,0,2,4,4,2,0,0,1,4,5,8,
	8,7,4,4,1,0,0,0,0,0,0,1,4,4,7,8,
	8,8,7,4,4,3,2,0,0,2,3,4,4,7,8,8,
	8,8,8,7,5,4,4,4,4,4,4,5,7,8,8,8,
	8,8,8,8,8,8,6,6,6,6,8,8,8,8,8,8
};
// above.xpm
static int alias_above[] = {
	8,8,8,8,8,7,6,6,6,6,6,6,6,6,7,8,
	8,8,8,8,7,4,4,4,4,4,4,4,4,4,4,7,
	8,8,8,8,6,4,1,0,0,0,0,0,0,1,4,6,
	8,8,8,8,6,4,2,2,2,2,2,2,2,2,4,6,
	8,8,8,8,6,4,4,4,4,4,4,4,4,4,4,6,
	8,7,6,6,5,4,0,0,0,0,0,0,0,0,4,6,
	7,4,4,4,4,4,0,0,0,0,0,0,0,0,4,6,
	6,4,2,2,3,4,0,0,0,0,0,0,0,0,4,6,
	6,4,3,3,4,4,0,0,0,0,0,0,0,0,4,6,
	6,4,4,4,4,4,3,2,2,2,2,2,2,3,4,6,
	6,4,2,2,2,3,4,4,4,4,4,4,4,4,5,8,
	6,4,2,2,2,2,2,2,2,4,6,8,8,8,8,8,
	6,4,2,2,2,2,2,2,2,4,6,8,8,8,8,8,
	6,4,3,2,2,2,2,2,2,4,6,8,8,8,8,8,
	7,4,4,4,4,4,4,4,4,4,7,8,8,8,8,8,
	8,7,6,6,6,6,6,6,6,7,8,8,8,8,8,8
};
// below.xpm
static int alias_below[] = {
	8,8,8,8,8,7,6,6,6,6,6,6,6,6,7,8,
	8,8,8,8,7,4,4,4,4,4,4,4,4,4,4,7,
	8,8,8,8,6,4,1,0,0,0,0,0,0,1,4,6,
	8,8,8,8,6,4,2,2,2,2,2,2,2,2,4,6,
	8,8,8,8,6,4,4,4,4,4,4,4,4,4,4,6,
	8,7,6,6,5,4,2,2,2,1,0,0,0,0,4,6,
	7,4,4,4,4,4,4,4,4,4,1,0,0,0,4,6,
	6,4,2,2,2,2,2,2,3,4,2,0,0,0,4,6,
	6,4,3,3,3,3,3,3,3,4,2,0,0,0,4,6,
	6,4,4,4,4,4,4,4,4,4,2,0,0,1,4,6,
	6,4,2,2,2,2,2,2,2,4,4,4,4,4,4,7,
	6,4,2,2,2,2,2,2,2,4,5,6,6,6,7,8,
	6,4,2,2,2,2,2,2,2,4,6,8,8,8,8,8,
	6,4,3,2,2,2,2,2,2,4,6,8,8,8,8,8,
	7,4,4,4,4,4,4,4,4,4,7,8,8,8,8,8,
	8,7,6,6,6,6,6,6,6,7,8,8,8,8,8,8
};

void Pixmaps::createPixmaps()
{
	if (pixmapsCreated)
		return;

	QColor aColor = KDecoration::options()->color(KDecoration::ColorTitleBar, true);
	QColor aColorBlend = KDecoration::options()->color(KDecoration::ColorTitleBlend, true);
	QColor iColor = KDecoration::options()->color(KDecoration::ColorTitleBar, false);
	QColor iColorBlend = KDecoration::options()->color(KDecoration::ColorTitleBlend, false);

	QColor aFont = KDecoration::options()->color(KDecoration::ColorFont, true);
	QColor iFont = KDecoration::options()->color(KDecoration::ColorFont, false);

	QColor aFrame = KDecoration::options()->color(KDecoration::ColorFrame, true);
	QColor iFrame = KDecoration::options()->color(KDecoration::ColorFrame, false);
	QColor aHover = KDecoration::options()->color(KDecoration::ColorButtonBg, true);
	QColor iHover = KDecoration::options()->color(KDecoration::ColorButtonBg, false);
	QColor aSunken = KDecoration::options()->color(KDecoration::ColorHandle, true);
	QColor iSunken = KDecoration::options()->color(KDecoration::ColorHandle, false);

	// MXLS
	QColorGroup widgetGroup;
	QWidget noname;
	widgetGroup = noname.colorGroup();
	QColor coground = widgetGroup.background();

	int titleSize = PorcelainHandler::titleSize();
	// int borderSize = (titleSize/4)-1;
	int buttonSize = (titleSize/2)+6;

	QPainter painter;
	KPixmap tempPixmap;

	// Let's begin with the title bar.
	active_titlebar = new QPixmap(1, buttonSize);
	painter.begin(active_titlebar);
	tempPixmap.resize(1, buttonSize);
	KPixmapEffect::gradient(tempPixmap, aColor, aColorBlend, KPixmapEffect::VerticalGradient);
	painter.drawPixmap(0, 0, tempPixmap);
	painter.end();

	inactive_titlebar = new QPixmap(1, buttonSize);
	painter.begin(inactive_titlebar);
	tempPixmap.resize(1, buttonSize);
	KPixmapEffect::gradient(tempPixmap, iColor, iColorBlend, KPixmapEffect::VerticalGradient);
	painter.drawPixmap(0, 0, tempPixmap);
	painter.end();

	active_titlebar_left = new QPixmap(1, titleSize-1);
	painter.begin(active_titlebar_left);
	tempPixmap.resize(1, titleSize-1);
	KPixmapEffect::gradient(tempPixmap, aColor, aColor, KPixmapEffect::VerticalGradient);
	painter.drawPixmap(0, 0, tempPixmap);
	painter.end();

	inactive_titlebar_left = new QPixmap(1, titleSize-1);
	painter.begin(inactive_titlebar_left);
	tempPixmap.resize(1, titleSize-1);
	KPixmapEffect::gradient(tempPixmap, iColor, iColor, KPixmapEffect::VerticalGradient);
	painter.drawPixmap(0, 0, tempPixmap);
	painter.end();

	active_titlebar_right = new QPixmap(1, titleSize-1);
	painter.begin(active_titlebar_right);
	tempPixmap.resize(1, titleSize-1);
	KPixmapEffect::gradient(tempPixmap, aColor, aColor, KPixmapEffect::VerticalGradient);
	painter.drawPixmap(0, 0, tempPixmap);
	painter.end();

	inactive_titlebar_right = new QPixmap(1, titleSize-1);
	painter.begin(inactive_titlebar_right);
	tempPixmap.resize(1, titleSize-1);
	KPixmapEffect::gradient(tempPixmap, iColor, iColor, KPixmapEffect::VerticalGradient);
	painter.drawPixmap(0, 0, tempPixmap);
	painter.end();

	// Let's create the button background.
	active_button_ground = new QPixmap(buttonSize, buttonSize);
	painter.begin(active_button_ground);
	tempPixmap.resize(buttonSize, buttonSize);
	tempPixmap.fill(coground);
	painter.drawPixmap(0, 0, tempPixmap);
	painter.end();
	inactive_button_ground = new QPixmap(buttonSize, buttonSize);
	painter.begin(inactive_button_ground);
	tempPixmap.resize(buttonSize, buttonSize);
	tempPixmap.fill(coground);
	painter.drawPixmap(0, 0, tempPixmap);
	painter.end();

	// Now, let's create the button icons!
	QPainter ikon;
	KPixmap grndPixmap;

	QImage *aGround = new QImage();
	QPixmap *taGround = new QPixmap(16, 16);
	ikon.begin(taGround);
	grndPixmap.resize(16, 16);
	if (PorcelainHandler::invertButton())
	{
		KPixmapEffect::gradient(grndPixmap, aColorBlend, aColor, KPixmapEffect::VerticalGradient);
	}
	else
	{
		KPixmapEffect::gradient(grndPixmap, aColor, aColorBlend, KPixmapEffect::VerticalGradient);
	}
	ikon.drawPixmap(0, 0, grndPixmap);
	*aGround = taGround->convertToImage();
	*aGround = aGround->convertDepth(32);
	ikon.end();
	QImage *iGround = new QImage();
	QPixmap *tiGround = new QPixmap(16, 16);
	ikon.begin(tiGround);
	grndPixmap.resize(16, 16);
	if (PorcelainHandler::invertButton())
	{
		KPixmapEffect::gradient(grndPixmap, iColorBlend, iColor, KPixmapEffect::VerticalGradient);
	}
	else
	{
		KPixmapEffect::gradient(grndPixmap, iColor, iColorBlend, KPixmapEffect::VerticalGradient);
	}
	ikon.drawPixmap(0, 0, grndPixmap);
	*iGround = tiGround->convertToImage();
	*iGround = iGround->convertDepth(32);
	ikon.end();

	// Some colors to use.
	int afr, afg, afb, ahr, ahg, ahb, asr, asg, asb;
	int ifr, ifg, ifb, ihr, ihg, ihb, isr, isg, isb;
	aFrame.getRgb(&afr, &afg, &afb);
	aHover.getRgb(&ahr, &ahg, &ahb);
	aSunken.getRgb(&asr, &asg, &asb);
	iFrame.getRgb(&ifr, &ifg, &ifb);
	iHover.getRgb(&ihr, &ihg, &ihb);
	iSunken.getRgb(&isr, &isg, &isb);
	// Lotsa work to do.
	// Zero...
	active_help_normal = new QImage(16, 16, 32);
	bitBlt(active_help_normal, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_help, *active_help_normal, afr, afg, afb);
	active_help_hover = new QImage(16, 16, 32);
	bitBlt(active_help_hover, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_help, *active_help_hover, ahr, ahg, ahb);
	active_help_sunken = new QImage(16, 16, 32);
	bitBlt(active_help_sunken, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_help, *active_help_sunken, asr, asg, asb);
	inactive_help_normal = new QImage(16, 16, 32);
	bitBlt(inactive_help_normal, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_help, *inactive_help_normal, ifr, ifg, ifb);
	inactive_help_hover = new QImage(16, 16, 32);
	bitBlt(inactive_help_hover, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_help, *inactive_help_hover, ihr, ihg, ihb);
	inactive_help_sunken = new QImage(16, 16, 32);
	bitBlt(inactive_help_sunken, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_help, *inactive_help_sunken, isr, isg, isb);
	// Six...
	active_max_normal = new QImage(16, 16, 32);
	bitBlt(active_max_normal, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_max, *active_max_normal, afr, afg, afb);
	active_max_hover = new QImage(16, 16, 32);
	bitBlt(active_max_hover, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_max, *active_max_hover, ahr, ahg, ahb);
	active_max_sunken = new QImage(16, 16, 32);
	bitBlt(active_max_sunken, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_max, *active_max_sunken, asr, asg, asb);
	inactive_max_normal = new QImage(16, 16, 32);
	bitBlt(inactive_max_normal, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_max, *inactive_max_normal, ifr, ifg, ifb);
	inactive_max_hover = new QImage(16, 16, 32);
	bitBlt(inactive_max_hover, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_max, *inactive_max_hover, ihr, ihg, ihb);
	inactive_max_sunken = new QImage(16, 16, 32);
	bitBlt(inactive_max_sunken, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_max, *inactive_max_sunken, isr, isg, isb);
	// Twelve...
	active_restore_normal = new QImage(16, 16, 32);
	bitBlt(active_restore_normal, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_restore, *active_restore_normal, afr, afg, afb);
	active_restore_hover = new QImage(16, 16, 32);
	bitBlt(active_restore_hover, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_restore, *active_restore_hover, ahr, ahg, ahb);
	active_restore_sunken = new QImage(16, 16, 32);
	bitBlt(active_restore_sunken, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_restore, *active_restore_sunken, asr, asg, asb);
	inactive_restore_normal = new QImage(16, 16, 32);
	bitBlt(inactive_restore_normal, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_restore, *inactive_restore_normal, ifr, ifg, ifb);
	inactive_restore_hover = new QImage(16, 16, 32);
	bitBlt(inactive_restore_hover, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_restore, *inactive_restore_hover, ihr, ihg, ihb);
	inactive_restore_sunken = new QImage(16, 16, 32);
	bitBlt(inactive_restore_sunken, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_restore, *inactive_restore_sunken, isr, isg, isb);
	// Eighteen
	active_min_normal = new QImage(16, 16, 32);
	bitBlt(active_min_normal, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_min, *active_min_normal, afr, afg, afb);
	active_min_hover = new QImage(16, 16, 32);
	bitBlt(active_min_hover, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_min, *active_min_hover, ahr, ahg, ahb);
	active_min_sunken = new QImage(16, 16, 32);
	bitBlt(active_min_sunken, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_min, *active_min_sunken, asr, asg, asb);
	inactive_min_normal = new QImage(16, 16, 32);
	bitBlt(inactive_min_normal, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_min, *inactive_min_normal, ifr, ifg, ifb);
	inactive_min_hover = new QImage(16, 16, 32);
	bitBlt(inactive_min_hover, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_min, *inactive_min_hover, ihr, ihg, ihb);
	inactive_min_sunken = new QImage(16, 16, 32);
	bitBlt(inactive_min_sunken, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_min, *inactive_min_sunken, isr, isg, isb);
	// Twenty four...
	active_close_normal = new QImage(16, 16, 32);
	bitBlt(active_close_normal, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_close, *active_close_normal, afr, afg, afb);
	active_close_hover = new QImage(16, 16, 32);
	bitBlt(active_close_hover, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_close, *active_close_hover, ahr, ahg, ahb);
	active_close_sunken = new QImage(16, 16, 32);
	bitBlt(active_close_sunken, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_close, *active_close_sunken, asr, asg, asb);
	inactive_close_normal = new QImage(16, 16, 32);
	bitBlt(inactive_close_normal, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_close, *inactive_close_normal, ifr, ifg, ifb);
	inactive_close_hover = new QImage(16, 16, 32);
	bitBlt(inactive_close_hover, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_close, *inactive_close_hover, ihr, ihg, ihb);
	inactive_close_sunken = new QImage(16, 16, 32);
	bitBlt(inactive_close_sunken, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_close, *inactive_close_sunken, isr, isg, isb);
	// Thirty...
	active_sticky_normal = new QImage(16, 16, 32);
	bitBlt(active_sticky_normal, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_sticky, *active_sticky_normal, afr, afg, afb);
	active_sticky_hover = new QImage(16, 16, 32);
	bitBlt(active_sticky_hover, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_sticky, *active_sticky_hover, ahr, ahg, ahb);
	active_sticky_sunken = new QImage(16, 16, 32);
	bitBlt(active_sticky_sunken, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_sticky, *active_sticky_sunken, asr, asg, asb);
	inactive_sticky_normal = new QImage(16, 16, 32);
	bitBlt(inactive_sticky_normal, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_sticky, *inactive_sticky_normal, ifr, ifg, ifb);
	inactive_sticky_hover = new QImage(16, 16, 32);
	bitBlt(inactive_sticky_hover, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_sticky, *inactive_sticky_hover, ihr, ihg, ihb);
	inactive_sticky_sunken = new QImage(16, 16, 32);
	bitBlt(inactive_sticky_sunken, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_sticky, *inactive_sticky_sunken, isr, isg, isb);
	// Thirty six...
	active_unsticky_normal = new QImage(16, 16, 32);
	bitBlt(active_unsticky_normal, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_unsticky, *active_unsticky_normal, afr, afg, afb);
	active_unsticky_hover = new QImage(16, 16, 32);
	bitBlt(active_unsticky_hover, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_unsticky, *active_unsticky_hover, ahr, ahg, ahb);
	active_unsticky_sunken = new QImage(16, 16, 32);
	bitBlt(active_unsticky_sunken, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_unsticky, *active_unsticky_sunken, asr, asg, asb);
	inactive_unsticky_normal = new QImage(16, 16, 32);
	bitBlt(inactive_unsticky_normal, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_unsticky, *inactive_unsticky_normal, ifr, ifg, ifb);
	inactive_unsticky_hover = new QImage(16, 16, 32);
	bitBlt(inactive_unsticky_hover, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_unsticky, *inactive_unsticky_hover, ihr, ihg, ihb);
	inactive_unsticky_sunken = new QImage(16, 16, 32);
	bitBlt(inactive_unsticky_sunken, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_unsticky, *inactive_unsticky_sunken, isr, isg, isb);
	// Forty two...
	active_above_normal = new QImage(16, 16, 32);
	bitBlt(active_above_normal, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_above, *active_above_normal, afr, afg, afb);
	active_above_hover = new QImage(16, 16, 32);
	bitBlt(active_above_hover, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_above, *active_above_hover, ahr, ahg, ahb);
	active_above_sunken = new QImage(16, 16, 32);
	bitBlt(active_above_sunken, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_above, *active_above_sunken, asr, asg, asb);
	inactive_above_normal = new QImage(16, 16, 32);
	bitBlt(inactive_above_normal, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_above, *inactive_above_normal, ifr, ifg, ifb);
	inactive_above_hover = new QImage(16, 16, 32);
	bitBlt(inactive_above_hover, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_above, *inactive_above_hover, ihr, ihg, ihb);
	inactive_above_sunken = new QImage(16, 16, 32);
	bitBlt(inactive_above_sunken, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_above, *inactive_above_sunken, isr, isg, isb);
	// Forty eight...
	active_below_normal = new QImage(16, 16, 32);
	bitBlt(active_below_normal, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_below, *active_below_normal, afr, afg, afb);
	active_below_hover = new QImage(16, 16, 32);
	bitBlt(active_below_hover, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_below, *active_below_hover, ahr, ahg, ahb);
	active_below_sunken = new QImage(16, 16, 32);
	bitBlt(active_below_sunken, 0, 0, aGround, 0, 0, 16, 16, 0);
	unicity(alias_below, *active_below_sunken, asr, asg, asb);
	inactive_below_normal = new QImage(16, 16, 32);
	bitBlt(inactive_below_normal, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_below, *inactive_below_normal, ifr, ifg, ifb);
	inactive_below_hover = new QImage(16, 16, 32);
	bitBlt(inactive_below_hover, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_below, *inactive_below_hover, ihr, ihg, ihb);
	inactive_below_sunken = new QImage(16, 16, 32);
	bitBlt(inactive_below_sunken, 0, 0, iGround, 0, 0, 16, 16, 0);
	unicity(alias_below, *inactive_below_sunken, isr, isg, isb);
	// Fifty four... Don't lose the count!
}

void Pixmaps::deletePixmaps()
{
	delete active_button_ground;
	active_button_ground = 0;
	delete inactive_button_ground;
	inactive_button_ground = 0;

	delete active_help_normal;
	active_help_normal = 0;
	delete active_max_normal;
	active_max_normal = 0;
	delete active_restore_normal;
	active_restore_normal = 0;
	delete active_min_normal;
	active_min_normal = 0;
	delete active_close_normal;
	active_close_normal = 0;
	delete active_sticky_normal;
	active_sticky_normal = 0;
	delete active_unsticky_normal;
	active_unsticky_normal = 0;
	delete active_above_normal;
	active_above_normal = 0;
	delete active_below_normal;
	active_below_normal = 0;
	
	delete active_help_hover;
	active_help_hover = 0;
	delete active_max_hover;
	active_max_hover = 0;
	delete active_restore_hover;
	active_restore_hover = 0;
	delete active_min_hover;
	active_min_hover = 0;
	delete active_close_hover;
	active_close_hover = 0;
	delete active_sticky_hover;
	active_sticky_hover = 0;
	delete active_unsticky_hover;
	active_unsticky_hover = 0;
	delete active_above_hover;
	active_above_hover = 0;
	delete active_below_hover;
	active_below_hover = 0;
	
	delete active_help_sunken;
	active_help_sunken = 0;
	delete active_max_sunken;
	active_max_sunken = 0;
	delete active_restore_sunken;
	active_restore_sunken = 0;
	delete active_min_sunken;
	active_min_sunken = 0;
	delete active_close_sunken;
	active_close_sunken = 0;
	delete active_sticky_sunken;
	active_sticky_sunken = 0;
	delete active_unsticky_sunken;
	active_unsticky_sunken = 0;
	delete active_above_sunken;
	active_above_sunken = 0;
	delete active_below_sunken;
	active_below_sunken = 0;

	delete inactive_help_normal;
	inactive_help_normal = 0;
	delete inactive_max_normal;
	inactive_max_normal = 0;
	delete inactive_restore_normal;
	inactive_restore_normal = 0;
	delete inactive_min_normal;
	inactive_min_normal = 0;
	delete inactive_close_normal;
	inactive_close_normal = 0;
	delete inactive_sticky_normal;
	inactive_sticky_normal = 0;
	delete inactive_unsticky_normal;
	inactive_unsticky_normal = 0;
	delete inactive_above_normal;
	inactive_above_normal = 0;
	delete inactive_below_normal;
	inactive_below_normal = 0;
	
	delete inactive_help_hover;
	inactive_help_hover = 0;
	delete inactive_max_hover;
	inactive_max_hover = 0;
	delete inactive_restore_hover;
	inactive_restore_hover = 0;
	delete inactive_min_hover;
	inactive_min_hover = 0;
	delete inactive_close_hover;
	inactive_close_hover = 0;
	delete inactive_sticky_hover;
	inactive_sticky_hover = 0;
	delete inactive_unsticky_hover;
	inactive_unsticky_hover = 0;
	delete inactive_above_hover;
	inactive_above_hover = 0;
	delete inactive_below_hover;
	inactive_below_hover = 0;
	
	delete inactive_help_sunken;
	inactive_help_sunken = 0;
	delete inactive_max_sunken;
	inactive_max_sunken = 0;
	delete inactive_restore_sunken;
	inactive_restore_sunken = 0;
	delete inactive_min_sunken;
	inactive_min_sunken = 0;
	delete inactive_close_sunken;
	inactive_close_sunken = 0;
	delete inactive_sticky_sunken;
	inactive_sticky_sunken = 0;
	delete inactive_unsticky_sunken;
	inactive_unsticky_sunken = 0;
	delete inactive_above_sunken;
	inactive_above_sunken = 0;
	delete inactive_below_sunken;
	inactive_below_sunken = 0;

	delete active_titlebar;
	active_titlebar = 0;
	delete active_titlebar_left;
	active_titlebar_left = 0;
	delete active_titlebar_right;
	active_titlebar_right = 0;

	delete inactive_titlebar;
	inactive_titlebar = 0;
	delete inactive_titlebar_left;
	inactive_titlebar_left = 0;
	delete inactive_titlebar_right;
	inactive_titlebar_right = 0;

	pixmapsCreated = false;
}

void Pixmaps::unicity(int* alias, QImage& work, int rr, int gg, int bb)
{
	int x, y, aa;
	int z = 0;
	uint pxl;

	QColorGroup widgetGroup;
	QWidget noname;
	widgetGroup = noname.colorGroup();
	QColor coground = widgetGroup.background();
	int tr, tg, tb;
	coground.getRgb(&tr, &tg, &tb);

	for (y=0; y<16; y++)
	{
		uint *line = (uint*)work.scanLine(y);
		for (x=0; x<16; x++)
		{
			switch (alias[z])
			{
				case 0:		// Keep background.
					break;
				case 1:
				case 2:
				case 3:		// Blend frame color and background gradient.
					pxl = line[x];
					line[x] = qRgb( (qRed(pxl)*(4-alias[z])+rr*alias[z])/4, (qGreen(pxl)*(4-alias[z])+gg*alias[z])/4, (qBlue(pxl)*(4-alias[z])+bb*alias[z])/4 );
					break;
				case 4:		// Replace with frame color
					line[x] = qRgb(rr, gg, bb);
					break;
				case 5:
				case 6:
				case 7:		// Blend title and frame colors.
					aa = alias[z] - 4;
					line[x] = qRgb( (rr*(4-aa)+tr*aa)/4, (gg*(4-aa)+tg*aa)/4, (bb*(4-aa)+tb*aa)/4 );
					break;
				case 8:		// Replace with title color.
					line[x] = qRgb(tr, tg, tb);
					break;
			}
			z++;
		}
	}
}

