//
// C++ Interface: porcelainbutton
//
// Description:
//
//
// Author: Remi Villatel <maxilys@tele2.fr>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef PORCELAINBUTTON_H
#define PORCELAINBUTTON_H

#include <qbutton.h>

#include "porcelainclient.h"
#include "enums.h"

class PorcelainClient;

class PorcelainButton : public QButton
{
Q_OBJECT
public:
	PorcelainButton(PorcelainClient *parent = 0, const char *name = 0, const QString &tip=NULL, ButtonType type = (ButtonType)0);
	~PorcelainButton();

	void setTipText(const QString &tip);

	void setOnAllDesktops(bool oad)	{ isOnAllDesktops = oad; repaint(false); }
	void setMaximized(bool max) { isMaximized = max; repaint(false); }
	QSize sizeHint() const;
	int lastMousePress() const { return m_lastMouse; }
	void reset() { repaint(false); }
	PorcelainClient* client() { return m_client; }

private:
	void enterEvent(QEvent *e);
	void leaveEvent(QEvent *e);
	void mousePressEvent(QMouseEvent *e);
	void mouseReleaseEvent(QMouseEvent *e);
	void drawButton(QPainter *painter);

	PorcelainClient *m_client;
	int m_lastMouse;
	ButtonType m_type;
	bool hover;
	bool isOnAllDesktops, isMaximized;
};

#endif
