//
// C++ Interface: porcelainhandler
//
// Description:
//
//
// Author: Remi Villatel <maxilys@tele2.fr>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef PORCELAINHANDLER_H
#define PORCELAINHANDLER_H

#include <kdecorationfactory.h>
#include <kdecoration.h>
#include <qobject.h>
#include <kconfig.h>

// Default button layout
const char default_left[]  = "M";
const char default_right[] = "HIAX";

class PorcelainHandler : public QObject, public KDecorationFactory
{
Q_OBJECT
public:
	PorcelainHandler();
	~PorcelainHandler();
	virtual bool reset(unsigned long changed);

	virtual KDecoration* createDecoration(KDecorationBridge*);

	static bool initialized() { return m_initialized; }
	static int titleSize() { return m_titleSize; }
	static int borderSize() { return (m_titleSize/4)-1; }
	static int buttonSize() { return (m_titleSize/2)+6; }
	static int buttonSpacing() { return m_buttonSpacing; }
	static bool invertButton() { return m_invertButton; }
	static bool centerTitle() { return m_centerTitle; }

private:
	void readConfig();
	static bool m_initialized;
	static int m_titleSize;
	static int m_borderSize;
	static int m_buttonSize;
	static int m_buttonSpacing;
	static bool m_invertButton;
	static bool m_centerTitle;
};

#endif
